/*
 * Exceptions.hpp
 *
 *  Created on: Nov 23, 2012
 *      Author: heber
 */

#ifndef SERIALZABLEPOTENTIALEXCEPTIONS_HPP_
#define SERIALZABLEPOTENTIALEXCEPTIONS_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <exception>
#include <boost/exception/all.hpp>

/** Base type for all exceptions regarding linear algebra.
 *
 */
struct SerializablePotentialException : virtual std::exception, virtual boost::exception { };

/** ========================== General error information ================== */

/** Exception information for ParserException: non-present key of an internal map.
 */
typedef boost::error_info< struct tag_SerializablePotentialKey, const std::string > SerializablePotentialKey;

/** ============================ Specific exceptions ====================== */

/** Exception thrown when the given parameter name/key does not exist
 */
struct SerializablePotentialIllegalKeyException : virtual SerializablePotentialException { };

/** Exception thrown when the value to parameter name/key is missing
 */
struct SerializablePotentialMissingValueException : virtual SerializablePotentialException { };

#endif /* EXCEPTIONS_HPP_ */
